--string mist.respawnInZone(string groupName ,string/table zoneName/tableOfZoneNames , boolean disperse ,number radius ,table vars )

-- what mission is this for?

--  number mist.utils.getHeadingPoints(table point1 ,table point2 , boolean corrected )
--  number mist.utils.get2DDist(table point1 ,table point2 )

--  table mist.getAvgPos(table unitNames )

--  vec3 Object.getPoint(Class Self )

soundFilename = "dummystring"
distsoundFilename = "dummystring2"
altsoundFilename = "dstr"

delaytime = 2.3

function playDelayedSound(sndfilename)
	trigger.action.outSound(sndfilename) --"Sounds/fileName.wav"
	return nil  -- oneshot
end

-- Function to play a sound based on the nearest 5-degree heading
function playSoundBasedOnHeading(hdg)
    -- Calculate the nearest heading divisible by 5
    local nearestHeading = math.floor((hdg + 2.5) / 5) * 5
	soundFilename = string.format("%03d.ogg", nearestHeading)
    -- Generate the filename based on the nearest heading

	local soundpath = "./Audio/M4/Sounds/"
    -- Call the outSound function with the filename
		--trigger.action.outText("hostilecontact.ogg", 5, false)
		--trigger.action.outText(soundFilename, 5, false)
	
	trigger.action.outSound("hostilecontact.ogg") --"Sounds/fileName.wav"
	--sequentially schedule the remaining phrases
	timer.scheduleFunction(playDelayedSound, soundFilename, timer.getTime() + delaytime) --
    
end

function playSoundBasedOnDistance(dst)
    -- Calculate the nearest 
    dst = math.floor(dst)
	distsoundFilename = string.format("%dmiles.ogg", dst)
 		
	--trigger.action.outText("playing(delayed): " .. distsoundFilename, 5, false)
	
	
	--sequentially schedule the remaining phrases
	timer.scheduleFunction(playDelayedSound, distsoundFilename, timer.getTime() + delaytime + 1.5) --
    
end


function playSoundBasedOnAltitude(alt)
    -- adjust to nearest 500 feet
    if alt <= 9750 then
        alt = math.floor((alt + 250)/500) * 500  -- 500 up to 9,500
    else
        alt = math.floor((alt + 500)/1000) * 1000  -- angels 10 up to angels 40
    end
		alt = alt - 1000

	altsoundFilename = string.format("%dalt.ogg", alt)
 		
	--trigger.action.outText("play(delayed): " .. altsoundFilename, 5, false)	
	--sequentially schedule the remaining phrases
	timer.scheduleFunction(playDelayedSound, altsoundFilename, timer.getTime() + delaytime + 2.5) --
    
end



--altsoundFilename


local invader_group = "RED Bombers-2"
--local self_group = "1APlayer Ramp Hot"
local pos1

local unitNames = {"PlayerRunwayStart", "PlayerRampHotStart", "PlayerColdDarkStart", "PlayerAirStart"}
local RedBomberUnits = {"RED Bombers-2-1", "RED Bombers-2-2"}
local RBunits = {}


if mist.groupIsDead('RED Bombers-2') == false then
	--RBunit[1] = Unit.getByName(RedBomberUnits[1])
	--RBunit[2] = Unit.getByName(RedBomberUnits[2])

	--trigger.action.outText("RED Bombers-2 GROUP is NOT dead ... getting position", 5, false)
	--trigger.action.outText("RB1 life = ", Unit.getByName(RedBomberUnits[1]):getLife(), 5, false)
	

	pos1 = mist.getAvgPos({'RED Bombers-2-1', 'RED Bombers-2-2'})
	
	for _, unitName in ipairs(unitNames) do
		local unit = Unit.getByName(unitName)
		
			if unit and unit:isActive() then
				-- local message = unitName .. " is active!"
				-- trigger.action.outText(message, 5) -- 
				
				local self_pos = Unit.getByName(unitName):getPoint()
				hdg = mist.utils.toDegree(mist.utils.getHeadingPoints(self_pos, pos1, true))
				hdg = math.floor(hdg)
				dst = mist.utils.metersToNM(mist.utils.get2DDist(self_pos, pos1))
				dst = math.floor(dst)
				
				unit_pos = unit:getPosition().p  -- position is a misnomer getPosition() returns a vector 'p' as position and unit vectors x, y, and z for orientation
				local alt = 3.3281 * pos1.y
				local land_h = 3.3281 * land.getHeight({x= pos1.x, y=pos1.z})
				
				alt = math.floor((alt + land_h)/100)
				alt = alt * 100
				

				if (dst > 2 and dst < 61) then
					trigger.action.outText('BRA: ' .. hdg .. ', ' .. dst .. ', ' .. alt, 5, true)
					playSoundBasedOnHeading(hdg)
					playSoundBasedOnDistance(dst)
					playSoundBasedOnAltitude(alt)
				
				
				elseif(dst < 3) then
					trigger.action.outText('Merged!', 5, false)
					trigger.action.outSound("merged.ogg")
					
				
				elseif (dst > 60) then
					trigger.action.outText('Negative Contact.', 5, false)
					trigger.action.outSound("negativecontact.ogg")
					
				end
				
				break		
			end	
	end
end

pos1 = nil



